#include <p33FJ128MC710.h>
#include <stdio.h>
#include <string.h>

//meine headerfiles
#include "lcd_drive.h"		//mein lcd treiber!!!

//globale variablen!!
unsigned char timerfertig;


//verschiedene definitionen
//langewartezeiten
//#define LAGEWARTEZEITEN
// ueberpruefe busyflag
#define BFCHECK

//Funktion ueberpruefen
//#define FKTTEST

//externe funktionen halt
//timerinterrupt
extern void _ISR _PWMInterrupt(void);
extern void _ISR _T3Interrupt(void);
extern void _ISR _T4Interrupt ( void );
extern void _ISR _DefaultInterrupt (void);

//main
extern void main(void);



void write ( unsigned char e,unsigned char rs, unsigned char data )
{
	//setze die rs und rw bits
	_rs = 0;
	_rw = 0;

	if ( rs == 1 )
		_rs = 1;

	//schreibe die enable signale
	switch ( e )
	{
		case 0 : _e1 = 0; _e2 = 0;break;
		case 1 : _e1 = 1; _e2 = 0;break;
		case 2 : _e1 = 0; _e2 = 1;break;
		case 3 : _e1 = 1; _e2 = 1;break;
		default: _e1 = 0 ; _e2 = 0;break;
	}

	//daten schreiben
	_d7 = 0;
	if ( data & 1<<7 )
		_d7 = 1;

	_d6 = 0;
	if ( data & 1<<6 )
		_d6 = 1;

	_d5 = 0;
	if ( data & 1<<5 )
		_d5 = 1;

	_d4 = 0;
	if ( data & 1<<4 )
		_d4 = 1;

	_d3 = 0;
	if ( data & 1<<3 )
		_d3 = 1;

	_d2 = 0;
	if ( data & 1<<2 )
		_d2 = 1;

	_d1 = 0;
	if ( data & 1<<1 )
		_d1 = 1;

	_d0 = 0;
	if ( data & 1<<0 )
		_d0 = 1;
		
	if ( data & 1<<0 )
		_d0 = 1;	

	_e1 = 0;
	_e2 = 0;
	return;
}

unsigned char read ( unsigned char e,unsigned char rs )
{
	unsigned char indata;
	unsigned char scheissen;


	_rs = 0;
	_rw = 1;

	if ( rs == 1 )
		_rs = 1;

	//E setzen

	switch ( e )
	{
		case 0 : _e1 = 0; _e2 = 0;break;
		case 1 : _e1 = 1; _e2 = 0;break;
		case 2 : _e1 = 0; _e2 = 1;break;
		default: _e1 = 0 ; _e2 = 0;break;
	}
	
	indata= 0;

	//alte daten loeschen
	_d7 = 0;
	_d6 = 0;
	_d5 = 0;
	_d4 = 0;
	_d3 = 0;
	_d2 = 0;
	_d1 = 0;
	_d0 = 0;

	//Tris auf eingang setzen!
	_d7tris = 1;
	_d6tris = 1;
	_d5tris = 1;
	_d4tris = 1;
	_d3tris = 1;
	_d2tris = 1;
	_d1tris = 1;
	_d0tris = 1;

	//daten einlesen und schreiben

	
	if ( _d7port = 1 )
		indata += 128;

	if ( _d6port = 1 )
		indata += 64;

	if ( _d5port = 1 )
		indata += 32;

	if ( _d4port = 1 )
		indata += 16;

	if ( _d3port = 1 )
		indata += 8;

	if ( _d2port = 1 )
		indata += 4;

	if ( _d1port = 1 )
		indata += 2;

	if ( _d0port = 1 )
		indata += 1;

	_e1 = 0;
	_e2 = 0;

	//Tris auf ausgang setzen!
	_d7tris = 0;
	_d6tris = 0;
	_d5tris = 0;
	_d4tris = 0;
	_d3tris = 0;
	_d2tris = 0;
	_d1tris = 0;
	_d0tris = 0;

	_d7port = 0;
	_d6port = 0;
	_d5port = 0;
	_d4port = 0;
	_d3port = 0;
	_d2port = 0;
	_d1port = 0;
	_d0port = 0;
	return ( indata );
}


unsigned char bfcheck ( unsigned char e )
{
	unsigned char bf;
	do
	{
		switch ( e )
		{
			case 0 :;break;
			case 1 : bf = read ( 1,0 );break;
			case 2 : bf = read ( 2,0 );break;
			default: ;break;
		}
		if ( bf < 128 )
			bf = 0;
		if ( bf >= 128 )
			bf =1;
	}
	while ( bf>=1 );
	return;
}
void lcdpos ( unsigned char e, unsigned char y, unsigned char x )
{
	switch ( y )
	{
		case 1: break;
		case 2: x+=0x40;
	}
	x+=128;
	bfcheck( 1 );
	bfcheck( 2 );
	write ( e,0,x );
	return;
}
void writetext ( unsigned char e, unsigned char text[] )
{
	unsigned char length;
	unsigned char totallength;
	totallength = strlen ( text );
	bfcheck(e);
	switch ( totallength )
	{
		case 0: write ( e,1,text[0] );bfcheck ( e );break;
		case 1: write ( e,1,text[0] );bfcheck ( e );break;
		default:
			for ( length = 0;length < totallength;length++ )
			{
				write ( e,1,text[length] );
				bfcheck ( 1 );
				bfcheck ( 2 );
			}
			; break;
	}
	bfcheck( 1 );
	bfcheck( 2 );
	return;
}
void timer_us ( unsigned char zeit )
{
	PR4 = zeit * 40;
	T4CONbits.TCKPS = 0;
	zeit++;
	timerfertig = 0;
	T4CONbits.TON = 1;
	while ( timerfertig != 1 )
		{};
	timerfertig = 0;
	return;
}

void timer_ms ( unsigned char zeit )
{
	PR4 = zeit * 156;
	T4CONbits.TCKPS = 3;
	T4CONbits.TON = 1;
	while ( timerfertig != 1 )
		{};
	timerfertig = 0;
	return;
}


void lcd_init ( void )
{
	//T4 schnell konfigurieren
	T4CON = 0b0010000000000000;

	//Setze aktuellen zaehlerstand auf null
	TMR4 = 0;
	_T4IE = 1;
	_T4IF = 0;
	_T4IP = 3;

	//Open Drain deaktivieren
	_d7open = 0;
	_d6open = 0;
	_d5open = 0;
	_d4open = 0;
	_d3open = 0;
	_d2open = 0;
	_d1open = 0;
	_d0open = 0;
	_e1open = 0;
	_e2open = 0;
	_rsopen = 0;
	_rwopen = 0;

	//TRIS registers
	_d7tris = 0;
	_d6tris = 0;
	_d5tris = 0;
	_d4tris = 0;
	_d3tris = 0;
	_d2tris = 0;
	_d1tris = 0;
	_d0tris = 0;
	_e1tris = 0;
	_e2tris = 0;
	_rstris = 0;
	_rwtris = 0;

	//LCD Initialisierung
#ifdef LANGEWARTEZEITEN
	timer_ms ( 100 );
#else
	timer_ms ( 30 );
#endif
	write ( 3,0,0b00111000 );
#ifdef LANGEWARTEZEITEN
	timer_us ( 80 );
#else
	timer_us ( 40 );
#endif
	write ( 3,0,0b00111000 );
#ifdef LANGEWARTEZEITEN
	timer_us ( 80 );
#else
	timer_us ( 40 );
#endif
	write ( 3,0,0b00111000 );
#ifdef LANGEWARTEZEITEN
	timer_us ( 80 );
#else
	timer_us ( 40 );
#endif
	write ( 3,0,0b00111000 );
	
#ifdef BFCHECK
	bfcheck(1);
	bfcheck(2);
#else
#ifdef LANGEWARTEZEITEN
	timer_us ( 80 );
#else
	timer_us ( 40 );
#endif
#endif
	write ( 3,0,0b00111000 );
#ifdef BFCHECK
	bfcheck(1);
	bfcheck(2);
#else
#ifdef LANGEWARTEZEITEN
	timer_us ( 80 );
#else
	timer_us ( 40 );
#endif
#endif
	write ( 3,0,0b00001100 );
#ifdef BFCHECK
	bfcheck(1);
	bfcheck(2);
#else
#ifdef LANGEWARTEZEITEN
	timer_us ( 80 );
#else
	timer_us ( 40 );
#endif
#endif
	write ( 3,0,0b00000001 );
#ifdef BFCHECK
	bfcheck(1);
	bfcheck(2);
#else
#ifdef LANGEWARTEZEITEN
	timer_ms ( 4 );
#else
	timer_ms ( 2 );
#endif
#endif
	write ( 3,0,0b00000011 );
#ifdef BFCHECK
	bfcheck(1);
	bfcheck(2);
#else
#ifdef LANGEWARTEZEITEN
	timer_ms ( 4 );
#else
	timer_ms ( 2 );
#endif
#endif
	write ( 3,0,0b00000110 );
#ifdef BFCHECK
	bfcheck(1);
	bfcheck(2);
#else
#ifdef LANGEWARTEZEITEN
	timer_us ( 80 );
#else
	timer_us ( 40 );
#endif
#endif

#ifdef FKTTEST
	unsigned char newtext[]={"Hallo Welt!! Ich habe mein LCD initalisiert!!"};
	lcdpos ( 3,1,3 );
	write ( 3,1,'H' );
	while(1);
#endif


return;
}
